#define _CRT_SECURE_NO_WARNINGS
#include "epm_handler_common.h"
#define ITK_err 919012
int ML_CheckCharLenth(EPM_action_message_t msg)
{
	printf("=========================校验字符长度 Start===================\n");
	auto startTime = std::chrono::high_resolution_clock::now();
	int ifail = ITK_ok;
	int  attachments_num = 0;
	tag_t  rootTask = NULLTAG, *attachments = NULLTAG;
	string type;
	vector<string> types;
	//获取任务对象
	EPM_ask_root_task(msg.task, &rootTask);
	//获取任务目标对象
	EPM_ask_attachments(rootTask, EPM_target_attachment, &attachments_num, &attachments);

	char *argflag = NULL, *argvalue = NULL, *arg = NULL;
	char arg1value[1024] = "", arg2value[1024] = "", arg3value[1024] = "";
	//获取参数
	int arg_cnt = TC_number_of_arguments(msg.arguments);
	printf("参数个数为：%d\n", arg_cnt);
	if (arg_cnt > 0)
	{
		for (int i = 0; i<arg_cnt; i++)
		{
			//获取下一个参数（从0开始）
			arg = TC_next_argument(msg.arguments);
			//获取参数的名称和值
			ifail = ITK_ask_argument_named_value((const char*)arg, &argflag, &argvalue);
			if (stricmp(argflag, "itemType") == 0)
			{
				if (argvalue != NULL)
				{
					//strcpy(arg1value, argvalue);
					type.assign(argvalue);
				}
			}
			else if (stricmp(argflag, "propertyName") == 0)
			{
				if (argvalue != NULL)
				{
					strcpy(arg2value, argvalue);
				}
			}
			else if (stricmp(argflag, "inPropertyName") == 0)
			{
				if (argvalue != NULL)
				{
					strcpy(arg3value, argvalue);
				}
			}
		}
	}

	//解析handler参数
	{
		int strnum = 0;
		types = split2(type, ",");
		if (types.size() == 0)
		{
			EMH_store_error_s1(EMH_severity_error, ITK_err, "未配置流程参数：-itemType");
			ifail = 1;
			goto end;
		}

	}

	POM_AM__set_application_bypass(true);
	for (int i = 0; i < attachments_num; i++)
	{
		char *itemType = NULL;

		AOM_ask_value_string(attachments[i], "object_type", &itemType);
		printf("type_class : %s,-itemType：%s \r\n", itemType, type.c_str());
		//过滤掉非版本的对象
		//if ((strcmp(itemType, arg1value) != 0))
		if (!isVecHasStr(types,itemType))
		{
			DOFREE(itemType);
			continue;
		}
		printf("方法执行\n");
		//获取属性
		char * propertyValue = NULL;
		AOM_ask_value_string(attachments[i], arg2value, &propertyValue);
		//判断是否超过40位
		int len = gbk_strlen(propertyValue);
		if (len > 40)
		{
			AOM_lock(attachments[i]);
			AOM_set_value_string(attachments[i], arg3value, "Y");
			AOM_save(attachments[i]);
			AOM_unlock(attachments[i]);
			AOM_refresh(attachments[i], FALSE);
		}
		else
		{
			AOM_lock(attachments[i]);
			AOM_set_value_string(attachments[i], arg3value, "N");
			AOM_save(attachments[i]);
			AOM_unlock(attachments[i]);
			AOM_refresh(attachments[i], FALSE);
		}
		DOFREE(propertyValue);
		DOFREE(itemType);
	}
	POM_AM__set_application_bypass(false);
	DOFREE(attachments); 
end:

	auto stopTime = std::chrono::high_resolution_clock::now();
	auto duration = std::chrono::duration_cast<std::chrono::microseconds>(stopTime - startTime);
	//std::cout << "ML_CheckCharLenth用时:" << duration.count() / 1000 << std::endl;
	string usetime = "ML_CheckCharLenth用时:";
	usetime.append(std::to_string(duration.count() / 1000));
	WriteLog(true, usetime.c_str());
	printf("=========================校验字符长度 End===================\n");
	return ifail;
}